<?php
/**
 * Created by PhpStorm.
 * User: heyu
 * Date: 2019-05-30
 * Time: 14:39
 */

namespace kwy\tp5util\annotation;


trait PropertyAnnotationTrait
{

    public function __get($name)
    {
        $re=new \ReflectionClass($this);

        $comm=$re->getDocComment();
        $matches='';
        $prop=preg_match_all('/(?<=(@property ))\S* \S*/i',$comm,$matches);
        foreach ($matches[0] as $v){
            $d=explode(' ',$v);
            if ($d[1]=='$'.$name){
                if(class_exists($d[0])){
                    $p=get_parent_class($d[0]);
                    if ($p=='think\Model'){
                        return model($d[0]);
                    }else{
                        return app($d[0]);
                    }
                }else{
                    if(get_parent_class($this)=='think\Model'){
                        return parent::__get($name);
                    }
                    if (interface_exists($d[0])){
                        return app(ltrim($d[0],"\\"));
                    }
                    throw new \Exception('不存在的类:'.$d[0]);
                }
                break;
            }
        }
        throw new \Exception('不存在的属性'.$name);
    }
}